package cn.com.tenlion.configcontent.service.contentcollect.impl;

import cn.com.tenlion.configcontent.pojo.dtos.contentlike.ContentLikeDTO;
import ink.wgink.app.AppTokenManager;
import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.app.AppTokenUser;
import ink.wgink.pojo.bos.UserInfoBO;
import ink.wgink.pojo.result.SuccessResult;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.util.map.HashMapUtil;
import ink.wgink.util.UUIDUtil;
import cn.com.tenlion.configcontent.dao.contentcollect.IContentCollectDao;
import cn.com.tenlion.configcontent.pojo.dtos.contentcollect.ContentCollectDTO;
import cn.com.tenlion.configcontent.pojo.vos.contentcollect.ContentCollectVO;
import cn.com.tenlion.configcontent.pojo.bos.contentcollect.ContentCollectBO;
import cn.com.tenlion.configcontent.pojo.pos.contentcollect.ContentCollectPO;
import cn.com.tenlion.configcontent.service.contentcollect.IContentCollectService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @ClassName: ContentCollectServiceImpl
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-08-02 09:15:31
 * @Version: 3.0
 **/
@Service
public class ContentCollectServiceImpl extends DefaultBaseService implements IContentCollectService {

    @Autowired
    private IContentCollectDao contentCollectDao;

    @Override
    public void save(ContentCollectVO contentCollectVO) {
        saveReturnId(contentCollectVO);
    }

    @Override
    public void save(String token, ContentCollectVO contentCollectVO) {
        saveReturnId(token, contentCollectVO);
    }

    @Override
    public String saveReturnId(ContentCollectVO contentCollectVO) {
        return saveReturnId(null, contentCollectVO);
    }

    @Override
    public String saveReturnId(String token, ContentCollectVO contentCollectVO) {
        /**
         * 查询当前的状态 , 如果是已经点赞则取消 , 如果没有点赞则保存
         */
        Map<String, Object> params = HashMapUtil.beanToMap(contentCollectVO);
        if (token != null) {
            AppTokenUser appTokenUser = AppTokenManager.getInstance().getToken(token).getAppTokenUser();
            contentCollectVO.setContentCollectUserName(appTokenUser.getName());
            contentCollectVO.setContentCollectUserIcon(appTokenUser.getAvatar());
        } else {
            UserInfoBO userInfoBO = this.securityComponent.getCurrentUser();
            contentCollectVO.setContentCollectUserName(userInfoBO.getUserName());
        }
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        List<ContentCollectDTO> list = list(params);
        if (list.size() > 0) {
            for(ContentCollectDTO dto : list) {
                delete(dto.getContentCollectId());
            }
            return "";
        }
        Map<String, Object> saveParams = HashMapUtil.beanToMap(contentCollectVO);
        String contentCollectId = UUIDUtil.getUUID();
        saveParams.put("contentCollectId", contentCollectId);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(saveParams);
        } else {
            setAppSaveInfo(token, saveParams);
        }
        contentCollectDao.save(saveParams);
        return contentCollectId;
    }

    @Override
    public void remove(List<String> ids) {
        remove(null, ids);
    }

    @Override
    public void remove(String token, List<String> ids) {
        Map<String, Object> params = getHashMap(2);
        params.put("contentCollectIds", ids);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        contentCollectDao.remove(params);
    }

    @Override
    public void delete(String contentCollectId) {
        contentCollectDao.delete(contentCollectId);
    }

    @Override
    public void update(String contentCollectId, ContentCollectVO contentCollectVO) {
        update(null, contentCollectId, contentCollectVO);
    }

    @Override
    public void update(String token, String contentCollectId, ContentCollectVO contentCollectVO) {
        Map<String, Object> params = HashMapUtil.beanToMap(contentCollectVO);
        params.put("contentCollectId", contentCollectId);
        if (StringUtils.isBlank(token)) {
            setUpdateInfo(params);
        } else {
            setAppUpdateInfo(token, params);
        }
        contentCollectDao.update(params);
    }

    @Override
    public ContentCollectDTO get(Map<String, Object> params) {
        return contentCollectDao.get(params);
    }

    @Override
    public ContentCollectDTO get(String contentCollectId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("contentCollectId", contentCollectId);
        return get(params);
    }

    @Override
    public ContentCollectBO getBO(Map<String, Object> params) {
        return contentCollectDao.getBO(params);
    }

    @Override
    public ContentCollectBO getBO(String contentCollectId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("contentCollectId", contentCollectId);
        return getBO(params);
    }

    @Override
    public ContentCollectPO getPO(Map<String, Object> params) {
        return contentCollectDao.getPO(params);
    }

    @Override
    public ContentCollectPO getPO(String contentCollectId) {
        Map<String, Object> params = super.getHashMap(2);
        params.put("contentCollectId", contentCollectId);
        return getPO(params);
    }

    @Override
    public List<ContentCollectDTO> list(Map<String, Object> params) {
        return contentCollectDao.list(params);
    }

    @Override
    public List<ContentCollectBO> listBO(Map<String, Object> params) {
        return contentCollectDao.listBO(params);
    }

    @Override
    public List<ContentCollectPO> listPO(Map<String, Object> params) {
        return contentCollectDao.listPO(params);
    }

    @Override
    public SuccessResultList<List<ContentCollectDTO>> listPage(ListPage page) {
        PageHelper.startPage(page.getPage(), page.getRows());
        List<ContentCollectDTO> contentCollectDTOs = list(page.getParams());
        PageInfo<ContentCollectDTO> pageInfo = new PageInfo<>(contentCollectDTOs);
        return new SuccessResultList<>(contentCollectDTOs, pageInfo.getPageNum(), pageInfo.getTotal());
    }

    @Override
    public Integer count(Map<String, Object> params) {
        Integer count = contentCollectDao.count(params);
        return count == null ? 0 : count;
    }

}